/** @file PCIe3021_LabView.h
 *
 *  @authors S. Beuque, C. Guinot, J. Krauth, N. Reibel, J. Rose, L. Sartory, S. Weber, L. ElBakali
 *  @date    Creation: 17.02.2015
 *  @date    $LastChangedDate$
 *  @version $LastChangedRevision$
 *
 *  @par DESCRIPTION
 *  xPCIe3021 LabView header file 
 *
 *  @par LICENCE
 *  @verbatim
 *  Copyright (C) 2009 - 2013 ADDI-DATA GmbH
 *
 *  ADDI-DATA GmbH
 *  Airpark Business Center
 *  Airport Boulevard B210
 *  77836 Rheinmnster
 *  Germany
 *  Tel: +49(0)7229/1847-0    |  Fax: +49(0)7229/1847-200
 *  http://www.addi-data-com  |  info@addi-data.com
 *  @endverbatim
 **/

short int __stdcall i_PCIe3021_GetNumberOfBoards(unsigned __int8 *NbrOfBoards);
short int __stdcall i_PCIe3021_GetBoardInformation(unsigned __int8 BoardIndex, unsigned long int IdentifierStringSize, char *Identifier, unsigned long int *UINumber, unsigned long int *DeviceNumber, unsigned long int *BusNumber, unsigned long int *BaseAddress0, unsigned long int *BaseAddress1, unsigned long int *BaseAddress2, unsigned long int *BaseAddress3, unsigned __int8 *Interrupt);
short int __stdcall i_PCIe3021_OpenBoardViaIndex(unsigned __int8 BoardIndex, unsigned long int *DeviceHandle); 
short int __stdcall i_PCIe3021_OpenBoardViaIdentifier(char *Identifier, unsigned long int *DeviceHandle);
short int __stdcall i_PCIe3021_CloseBoard(unsigned long int DeviceHandle);
short int __stdcall i_PCIe3021_GetDLLVersion(unsigned long int *Version);
short int __stdcall i_PCIe3021_GetDeviceDriverVersion(unsigned long int DeviceHandle, unsigned long int *Version);

short int __stdcall i_PCIe3021_SetLabViewInterrupt(unsigned long int DeviceHandle, LVUserEventRef *LabViewEventRef);
short int __stdcall i_PCIe3021_ResetLabViewInterrupt(unsigned long int DeviceHandle);

short int __stdcall i_PCIe3021_Read1DigitalInput(unsigned long int DeviceHandle, unsigned __int8 Channel, unsigned __int8 *Value);
short int __stdcall i_PCIe3021_Read4DigitalInputs(unsigned long int DeviceHandle, unsigned __int8 *Value);
short int __stdcall i_PCIe3021_Set1DigitalOutputOn(unsigned long int DeviceHandle, unsigned __int8 Channel);
short int __stdcall i_PCIe3021_Set1DigitalOutputOff(unsigned long int DeviceHandle, unsigned __int8 Channel);
short int __stdcall i_PCIe3021_Set4DigitalOutputsOn(unsigned long int DeviceHandle, unsigned __int8 Mask);
short int __stdcall i_PCIe3021_Set4DigitalOutputsOff(unsigned long int DeviceHandle, unsigned __int8 Mask);
short int __stdcall i_PCIe3021_SetDigitalOutputMemoryOn(unsigned long int DeviceHandle); 
short int __stdcall i_PCIe3021_SetDigitalOutputMemoryOff(unsigned long int DeviceHandle);
short int __stdcall i_PCIe3021_Get1DigitalOutputStatus(unsigned long int DeviceHandle, unsigned __int8 Channel, unsigned __int8 *OutputsStatus); 
short int __stdcall i_PCIe3021_Get4DigitalOutputsStatus(unsigned long int DeviceHandle, unsigned __int8 *OutputsStatus);

short int __stdcall i_PCIe3021_InitAndStartTimer(unsigned long int DeviceHandle, unsigned __int8 TimerMode, unsigned __int8 TimeBase, unsigned __int8 OutputMode, unsigned __int8 InterruptEnabled, unsigned short int ReloadValue);
short int __stdcall i_PCIe3021_StopTimer(unsigned long int DeviceHandle); 
short int __stdcall i_PCIe3021_ReadTimerStatus(unsigned long int DeviceHandle, unsigned __int8 *TimerStatus, unsigned __int8 *SoftwareTriggerStatus, unsigned short int *TimerValue);
short int __stdcall i_PCIe3021_ReadTimerValue(unsigned long int DeviceHandle, unsigned short int *TimerValue);
short int __stdcall i_PCIe3021_TriggerTimer(unsigned long int DeviceHandle); 

short int __stdcall i_PCIe3021_SetAnalogInputMode(unsigned long int DeviceHandle, unsigned __int8 InputMode);
short int __stdcall i_PCIe3021_GetAnalogInputMode(unsigned long int DeviceHandle, unsigned __int8 *InputMode); 
short int __stdcall i_PCIe3021_InitAndStartAnalogInputSequence(unsigned long int DeviceHandle, unsigned long int SequenceCount, unsigned long int SequenceBeforeInterrupt, unsigned __int8 ChannelCount, unsigned __int8 *Channel, unsigned __int8 *Gain, unsigned __int8 *Polarity, unsigned long int ConvertingTime, unsigned long int DelayTime, unsigned __int8 SoftTriggerMode, unsigned __int8 ExtTriggerMode, unsigned long int SequenceTriggerCount);
short int __stdcall i_PCIe3021_ReadMoreAnalogInputs(unsigned long int DeviceHandle, unsigned __int8 ChannelCount, unsigned __int8 *Channel, unsigned __int8 *Gain, unsigned __int8 *Polarity, unsigned long int ConvertingTime, unsigned __int8 InterruptFlag, unsigned __int8 SoftTriggerMode, unsigned __int8 ExtTriggerMode, unsigned short int *ChannelValue);
short int __stdcall i_PCIe3021_Read1AnalogInput(unsigned long int DeviceHandle, unsigned __int8 Channel, unsigned __int8 Gain, unsigned __int8 Polarity, unsigned long int ConvertingTime, unsigned __int8 InterruptFlag, unsigned __int8 SoftTriggerMode, unsigned __int8 ExtTriggerMode, unsigned short int *ChannelValue);
short int __stdcall i_PCIe3021_InitAndStartAutoRefreshAcquisition(unsigned long int DeviceHandle, unsigned __int8 ChannelCount, unsigned __int8 *Channel, unsigned __int8 *Gain, unsigned __int8 *Polarity, unsigned long int ConvertingTime, unsigned long int **Channels);
short int __stdcall i_PCIe3021_StopAnalogAcquisition(unsigned long int DeviceHandle); 
short int __stdcall i_PCIe3021_TriggerAnalogAcquisition(unsigned long int DeviceHandle); 
short int __stdcall i_PCIe3021_GetAnalogInputChannelsNbr(unsigned long int DeviceHandle, unsigned __int8 *NumberOfInputChannels); 

long  int __stdcall l_PCIe3021_ReadSequenceData(unsigned long int DeviceHandle, unsigned long int Size, void *Data);
