// Here goes constant declarations
#ifndef __PCIE3021_H
#define __PCIE3021_H

/* Digital input/output related */
#define	PCIE3021_DIGITAL_INPUT_NUMBER			4
#define	PCIE3021_DIGITAL_OUTPUT_NUMBER			4

/* Timer mode */
#define PCIE3021_TIMER_MODE_2					0
#define PCIE3021_TIMER_MODE_3					1

/* Delay mode (all other values > 0 are actual delay values) */
#define PCIE3021_NO_DELAY						0

/* Analog acquisition cycle (all other values > 0 are actual number of sequences) */
#define PCIE3021_CONTINUOUS_CYCLE				0

/* Time base */
#define PCIE3021_TIME_BASE_MICROSECONDS			0
#define PCIE3021_TIME_BASE_MILLISECONDS			1
#define PCIE3021_TIME_BASE_SECONDS				2

/* Output mode */
#define PCIE3021_OUTPUT_DISABLED				0
#define PCIE3021_OUTPUT_ENABLED					1
#define PCIE3021_OUTPUT_INVERTED				2

/* External trigger mode */
#define PCIE3021_EXT_TRIGGER_DISABLED			0x0
#define PCIE3021_EXT_TRIGGER_ENABLED_LOW		0x1
#define PCIE3021_EXT_TRIGGER_ENABLED_HIGH		0x2
#define PCIE3021_EXT_TRIGGER_ENABLED_BOTH		0x3

// Software trigger mode
#define PCIE3021_SOFT_TRIGGER_DISABLED			0x0
#define PCIE3021_SOFT_TRIGGER_ENABLED			0x1

/* Trigger types */
#define PCIE3021_TRIGGER_ONE_SHOT			0x0
#define PCIE3021_TRIGGER_SEQUENCE_TRIGGER		0x8
#define PCIE3021_TRIGGER_SINGLE_SEQUENCE		0xC

/* Analog output mode */
#define PCIE3021_OUTPUT_MODE_UNIPOLAR			0
#define PCIE3021_OUTPUT_MODE_BIPOLAR			1

/* Analog input modes */
#define PCIE3021_INPUT_MODE_UNDEFINED			0
#define PCIE3021_INPUT_MODE_SINGLE_ENDED		1
#define PCIE3021_INPUT_MODE_DIFFERENTIAL		2

/* Gain values */
#define PCIE3021_GAIN_1							0
#define PCIE3021_GAIN_2							1
#define PCIE3021_GAIN_5							2
#define PCIE3021_GAIN_10						3

/* Analog inputs resolution */
#define ADC_CONVERTER_HALF 0x8000 // chqnged
#define ADC_CONVERTER_MAX 0xFFFF //changed

#endif
