unit AnalogInputSequenceUnit;

interface

uses
  Types, Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls , PCIe3021, ExtCtrls;

type
  TForm1 = class(TForm)
    Channel0CheckBox: TCheckBox;
    Channel1CheckBox: TCheckBox;
    Channel2CheckBox: TCheckBox;
    Channel3CheckBox: TCheckBox;
    Channel4CheckBox: TCheckBox;
    Channel5CheckBox: TCheckBox;
    Channel6CheckBox: TCheckBox;
    Channel7CheckBox: TCheckBox;
    Channel8CheckBox: TCheckBox;
    Channel9CheckBox: TCheckBox;
    Channel10CheckBox: TCheckBox;
    Channel11CheckBox: TCheckBox;
    Channel12CheckBox: TCheckBox;
    Channel13CheckBox: TCheckBox;
    Channel14CheckBox: TCheckBox;
    Channel15CheckBox: TCheckBox;
    SelectAllChCheckBox: TCheckBox;
    ConvertingTimeEdit: TEdit;
    StartSequenceButton: TButton;
    AnalogInpModeGroupBox: TGroupBox;
    SERadioButton: TRadioButton;
    DiffRadioButton: TRadioButton;
    Label1: TLabel;
    StopButton: TButton;
    sequenceBeforeInterruptEdit: TEdit;
    Label2: TLabel;
    resultLabel0: TLabel;
    Timer1: TTimer;
    resultLabel1: TLabel;
    resultLabel2: TLabel;
    resultLabel3: TLabel;
    resultLabel4: TLabel;
    resultLabel5: TLabel;
    resultLabel6: TLabel;
    resultLabel7: TLabel;
    resultLabel8: TLabel;
    resultLabel9: TLabel;
    resultLabel10: TLabel;
    resultLabel11: TLabel;
    resultLabel12: TLabel;
    resultLabel13: TLabel;
    resultLabel14: TLabel;
    resultLabel15: TLabel;
    DebugLabel: TLabel;
    IRCButton: TButton;
    procedure SelectAllChCheckBoxClick(Sender: TObject);
    procedure StartSequenceButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure StopButtonClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure SERadioButtonClick(Sender: TObject);
    procedure DiffRadioButtonClick(Sender: TObject);
    procedure Channel0CheckBoxClick(Sender: TObject);
    procedure Channel1CheckBoxClick(Sender: TObject);
    procedure Channel2CheckBoxClick(Sender: TObject);
    procedure Channel3CheckBoxClick(Sender: TObject);
    procedure Channel4CheckBoxClick(Sender: TObject);
    procedure Channel5CheckBoxClick(Sender: TObject);
    procedure Channel6CheckBoxClick(Sender: TObject);
    procedure Channel7CheckBoxClick(Sender: TObject);
    procedure Channel8CheckBoxClick(Sender: TObject);
    procedure Channel9CheckBoxClick(Sender: TObject);
    procedure Channel10CheckBoxClick(Sender: TObject);
    procedure Channel11CheckBoxClick(Sender: TObject);
    procedure Channel12CheckBoxClick(Sender: TObject);
    procedure Channel13CheckBoxClick(Sender: TObject);
    procedure Channel14CheckBoxClick(Sender: TObject);
    procedure Channel15CheckBoxClick(Sender: TObject);
    procedure IRCButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  i_ReturnValue      : Integer;
  h_BoardHandle      : THandle;
  b_ReceiveInterrupt : word;

  sequenceBeforeInterrupt : LongWord ;

  b_InterruptSource : Byte;
  channelCount : Byte ;
  channelArray : array of byte;
  
  values : Array of word;
  valuesToDisplay : Array[0..15] of word;

  //variable for debug purpose
  li_read :LongInt;

implementation

{$R *.dfm}

Procedure v_InterruptRoutine   (h_BoardHandle       : THANDLE;
                                b_FIFOOverflow      : Byte;
								                dw_InterruptSource  : Byte;
                                b_InterruptMask     : Byte;
                                var w_Args          : word;
								                dw_ArgsCount        : longword);cdecl;

  var
    read : LongInt;
    I : Integer;
	Begin
     SetLength(values, (dw_ArgsCount * sizeof(word)) * sequenceBeforeInterrupt);

     b_InterruptSource := dw_InterruptSource;

     if (( dw_InterruptSource  and 4) = 4) then
     begin

        //Internal sequence fifo overflow
        if (( b_InterruptMask  and 4) = 4) then
        begin
          (* Stop the acquisition *)
            i_ReturnValue := i_PCIe3021_StopAnalogAcquisition(h_BoardHandle);
        end;

        b_ReceiveInterrupt := b_ReceiveInterrupt + 1 ;

        read := l_PCIe3021_ReadSequenceData(h_BoardHandle, (dw_ArgsCount * sequenceBeforeInterrupt) * sizeof(word) , values[0]);
        li_read := read;

        if (read = -1) or (read = 0) then
        begin
        // display the values
        valuesToDisplay[0]:= 32767;   // display 0V
        valuesToDisplay[1]:= 32767;   // display 0V
        valuesToDisplay[2]:= 32767;   // display 0V
        valuesToDisplay[3]:= 32767;   // display 0V
        valuesToDisplay[4]:= 32767;   // display 0V
        valuesToDisplay[5]:= 32767;   // display 0V
        valuesToDisplay[6]:= 32767;   // display 0V
        valuesToDisplay[7]:= 32767;   // display 0V
        valuesToDisplay[8]:= 32767;   // display 0V
        valuesToDisplay[9]:= 32767;   // display 0V
        valuesToDisplay[10]:= 32767;   // display 0V
        valuesToDisplay[11]:= 32767;   // display 0V
        valuesToDisplay[12]:= 32767;   // display 0V
        valuesToDisplay[13]:= 32767;   // display 0V
        valuesToDisplay[14]:= 32767;   // display 0V
        valuesToDisplay[15]:= 32767;   // display 0V
         exit;
        end
        else
        begin

        // display the values
        for I := 0 to channelCount - 1   do  // (dw_ArgsCount-1)
        begin
        valuesToDisplay[channelArray[I]]:= values[I]; 
        end;

        end;

     end
     else
     begin
  
      //interrupt fifo overflow. That means that your software do not handle the interrupts fast enough.
     if (b_FIFOOverflow  <> 0) then
        begin
          (* Stop the acquisition *)
        i_ReturnValue := i_PCIe3021_StopAnalogAcquisition(h_BoardHandle);
        // display the values
        valuesToDisplay[0]:= 32767;   // display 0V
        valuesToDisplay[1]:= 32767;   // display 0V
        valuesToDisplay[2]:= 32767;   // display 0V
        valuesToDisplay[3]:= 32767;   // display 0V
        valuesToDisplay[4]:= 32767;   // display 0V
        valuesToDisplay[5]:= 32767;   // display 0V
        valuesToDisplay[6]:= 32767;   // display 0V
        valuesToDisplay[7]:= 32767;   // display 0V
        valuesToDisplay[8]:= 32767;   // display 0V
        valuesToDisplay[9]:= 32767;   // display 0V
        valuesToDisplay[10]:= 32767;   // display 0V
        valuesToDisplay[11]:= 32767;   // display 0V
        valuesToDisplay[12]:= 32767;   // display 0V
        valuesToDisplay[13]:= 32767;   // display 0V
        valuesToDisplay[14]:= 32767;   // display 0V
        valuesToDisplay[15]:= 32767;   // display 0V

        end;

     //PLD Fifo overflow. This stop the acquisition.
     if (( dw_InterruptSource  and 10) = 10) then
        begin
          (* Stop the acquisition *)
        //i_ReturnValue := i_PCIe3021_StopAnalogAcquisition(h_BoardHandle);
        // display the values
        valuesToDisplay[0]:= 32767;   // display 0V
        valuesToDisplay[1]:= 32767;   // display 0V
        valuesToDisplay[2]:= 32767;   // display 0V
        valuesToDisplay[3]:= 32767;   // display 0V
        valuesToDisplay[4]:= 32767;   // display 0V
        valuesToDisplay[5]:= 32767;   // display 0V
        valuesToDisplay[6]:= 32767;   // display 0V
        valuesToDisplay[7]:= 32767;   // display 0V
        valuesToDisplay[8]:= 32767;   // display 0V
        valuesToDisplay[9]:= 32767;   // display 0V
        valuesToDisplay[10]:= 32767;   // display 0V
        valuesToDisplay[11]:= 32767;   // display 0V
        valuesToDisplay[12]:= 32767;   // display 0V
        valuesToDisplay[13]:= 32767;   // display 0V
        valuesToDisplay[14]:= 32767;   // display 0V
        valuesToDisplay[15]:= 32767;   // display 0V

        end;

     end;

    
	End;

procedure TForm1.FormCreate(Sender: TObject);
  Var
     b_NbrOfBoardFound      : Byte;

  begin
         // display the values
        valuesToDisplay[0]:= 32767;   // display 0V
        valuesToDisplay[1]:= 32767;   // display 0V
        valuesToDisplay[2]:= 32767;   // display 0V
        valuesToDisplay[3]:= 32767;   // display 0V
        valuesToDisplay[4]:= 32767;   // display 0V
        valuesToDisplay[5]:= 32767;   // display 0V
        valuesToDisplay[6]:= 32767;   // display 0V
        valuesToDisplay[7]:= 32767;   // display 0V
        valuesToDisplay[8]:= 32767;   // display 0V
        valuesToDisplay[9]:= 32767;   // display 0V
        valuesToDisplay[10]:= 32767;   // display 0V
        valuesToDisplay[11]:= 32767;   // display 0V
        valuesToDisplay[12]:= 32767;   // display 0V
        valuesToDisplay[13]:= 32767;   // display 0V
        valuesToDisplay[14]:= 32767;   // display 0V
        valuesToDisplay[15]:= 32767;   // display 0V

      Timer1.Enabled := False;
			{* Get the number of APCIe-3021 found  *}
			i_ReturnValue := i_PCIe3021_GetNumberOfBoards (b_NbrOfBoardFound);

      {* Get the board handle *}
      i_ReturnValue := i_PCIe3021_OpenBoardViaIndex (0, h_BoardHandle);

      {* Set Board Routine *}
      i_ReturnValue := i_PCIe3021_SetBoardIntRoutine(h_BoardHandle, @v_InterruptRoutine);

      StopButton.Enabled := False;
      StartSequenceButton.Enabled := True;

end;

procedure TForm1.SelectAllChCheckBoxClick(Sender: TObject);
begin
  IF (SelectAllChCheckBox.Checked = True) THEN
    begin
    if Channel0CheckBox.Visible=True then
    Channel0CheckBox.Checked := True;

    if Channel1CheckBox.Visible=True then
    Channel1CheckBox.Checked := True;

    if Channel2CheckBox.Visible=True then
    Channel2CheckBox.Checked := True;

    if Channel3CheckBox.Visible=True then
    Channel3CheckBox.Checked := True;

    if Channel4CheckBox.Visible=True then
    Channel4CheckBox.Checked := True;

    if Channel5CheckBox.Visible=True then
    Channel5CheckBox.Checked := True;

    if Channel6CheckBox.Visible=True then
    Channel6CheckBox.Checked := True;

    if Channel7CheckBox.Visible=True then
    Channel7CheckBox.Checked := True;

    if Channel8CheckBox.Visible=True then
    Channel8CheckBox.Checked := True;

    if Channel9CheckBox.Visible=True then
    Channel9CheckBox.Checked := True;

    if Channel10CheckBox.Visible=True then
    Channel10CheckBox.Checked := True;

    if Channel11CheckBox.Visible=True then
    Channel11CheckBox.Checked := True;

    if Channel12CheckBox.Visible=True then
    Channel12CheckBox.Checked := True;

    if Channel13CheckBox.Visible=True then
    Channel13CheckBox.Checked := True;

    if Channel14CheckBox.Visible=True then
    Channel14CheckBox.Checked := True;

    if Channel15CheckBox.Visible=True then
    Channel15CheckBox.Checked := True;
    end
  else
    begin
    Channel0CheckBox.Checked := False;
    Channel1CheckBox.Checked := False;
    Channel2CheckBox.Checked := False;
    Channel3CheckBox.Checked := False;
    Channel4CheckBox.Checked := False;
    Channel5CheckBox.Checked := False;
    Channel6CheckBox.Checked := False;
    Channel7CheckBox.Checked := False;
    Channel8CheckBox.Checked := False;
    Channel9CheckBox.Checked := False;
    Channel10CheckBox.Checked := False;
    Channel11CheckBox.Checked := False;
    Channel12CheckBox.Checked := False;
    Channel13CheckBox.Checked := False;
    Channel14CheckBox.Checked := False;
    Channel15CheckBox.Checked := False;
    end ;
end;

procedure TForm1.StartSequenceButtonClick(Sender: TObject);
var
    convertingTime : LongWord ;
    gainArray : array of byte;
    polarityArray : array of byte;

    var I, N, J: LongWord;

begin

   N :=0;
   J :=0;

  {*Count the number of channel*}
  for I := 0 to 15 do
  begin
    if (FindComponent('Channel'+IntToStr(I)+'CheckBox') as TCheckBox).Checked then
    Inc(N);
  end;

  channelCount:=N;

  SetLength(gainArray,channelCount);
  SetLength(polarityArray,channelCount);
  SetLength(channelArray,channelCount);

  if (channelCount = 0) then
  Begin
    ShowMessage('Select at least one channel');
    exit;
  end ;

  {*Check the analog input mode*}
  if not (SERadioButton.Checked) and not (DiffRadioButton.Checked) then
    Begin
    ShowMessage('Please choose the input mode');
    exit;
    end
  else
    Begin
    if (SERadioButton.Checked) then
    i_PCIe3021_SetAnalogInputMode(h_BoardHandle, PCIE3021_INPUT_MODE_SINGLE_ENDED);

    if (DiffRadioButton.Checked) then
    i_PCIe3021_SetAnalogInputMode(h_BoardHandle, PCIE3021_INPUT_MODE_DIFFERENTIAL);
    end;

  {*Check the Converting Time*}
  convertingTime := StrToInt(ConvertingTimeEdit.Text);
  if ( convertingTime <5 ) or (convertingTime>  65535000) then
  Begin
    ShowMessage('Converting time : invalid value');
    exit;
  end;

  {*Check the sequenceBeforeInterrupt*}
  sequenceBeforeInterrupt := StrToInt(sequenceBeforeInterruptEdit.Text);
  if ( sequenceBeforeInterrupt <1 ) then
  Begin
    ShowMessage('Sequence before interrupt : invalid value');
    exit;
  end;

 {*Construct the gain and polarity array*}
   for I := 0 to channelCount-1 do
    gainArray[I]      := PCIE3021_GAIN_1;     //0
    
   for I := 0 to channelCount-1 do
    polarityArray[I]  := PCIE3021_OUTPUT_MODE_BIPOLAR;  //1

 {*Construct the channel array*}
   for I := 0 to 15 do   // channelCount-1
   begin
    if (FindComponent('Channel'+IntToStr(I)+'CheckBox') as TCheckBox).Checked then
    begin
    channelArray [J] := I ;
    J := J+1;
    end;
   end;

 {*Start the sequence acquisition*}
 i_ReturnValue := i_PCIe3021_InitAndStartAnalogInputSequence(h_BoardHandle,
                                                             0,  // Continuous
                                                             sequenceBeforeInterrupt,
                                                             channelCount,
                                                             channelArray[0],
                                                             gainArray[0],
                                                             polarityArray[0],
                                                             convertingTime,
                                                             0,  // Delay time : disabled
                                                             0,  // Soft trigger mode : disabled
                                                             0,  // Hardware trigger mode : disabled
                                                             0); // Sequence trigger count : disabled



  if ( i_ReturnValue = -1 )  then
  Begin
    ShowMessage('i_PCIe3021_InitAndStartAnalogInputSequence Error : The device handle parameter is wrong ');
    exit;
  end
  else if (i_ReturnValue = -2)then
  Begin
    ShowMessage('i_PCIe3021_InitAndStartAnalogInputSequence Error : The sequence size is wrong ');
    exit;
  end
  else if (i_ReturnValue = -3)then
  Begin
    ShowMessage('i_PCIe3021_InitAndStartAnalogInputSequence Error : The input mode has not been set ');
    exit;
  end
  else if (i_ReturnValue = -4)then
  Begin
    ShowMessage('i_PCIe3021_InitAndStartAnalogInputSequence Error : A channel index is invalid (single-ended mode)');
    exit;
  end
  else if (i_ReturnValue = -5)then
  Begin
    ShowMessage('i_PCIe3021_InitAndStartAnalogInputSequence Error : A gain value is wrong ');
    exit;
  end
  else if (i_ReturnValue = -6)then
  Begin
    ShowMessage('i_PCIe3021_InitAndStartAnalogInputSequence Error :  A polarity value is wrong ');
    exit;
  end
  else if (i_ReturnValue = -7)then
  Begin
    ShowMessage('i_PCIe3021_InitAndStartAnalogInputSequence Error :  The converting time is invalid ');
    exit;
  end

  else if (i_ReturnValue = -8)then
  Begin
    ShowMessage('i_PCIe3021_InitAndStartAnalogInputSequence Error :  The delay time is invalid ');
    exit;
  end

  else if (i_ReturnValue = -9)then
  Begin
    ShowMessage('i_PCIe3021_InitAndStartAnalogInputSequence Error :  The interrupt routine is not installed ');
    exit;
  end

  else if (i_ReturnValue = -10)then
  Begin
    ShowMessage('i_PCIe3021_InitAndStartAnalogInputSequence Error : dw_SequenceBeforeInterrupt is not valid ');
    exit;
  end

  else if (i_ReturnValue = -11)then
  Begin
    ShowMessage('i_PCIe3021_InitAndStartAnalogInputSequence Error :  (b_ChannelCount * dw_SequenceBeforeInterrupt) is not a multiple of 4 ');
    exit;
  end

  else if (i_ReturnValue = -12)then
  Begin
    ShowMessage('i_PCIe3021_InitAndStartAnalogInputSequence Error : both software and hardware trigger are enabled. In that case, they must have the same type (one shot, sequence trigger or single sequence) ');
    exit;
  end

  else if (i_ReturnValue = -13)then
  Begin
    ShowMessage('i_PCIe3021_InitAndStartAnalogInputSequence Error :  Error while calling IOCTL function (wrong handle ?) ');
    exit;
  end
   else if (i_ReturnValue < -13)then
  Begin
    ShowMessage('i_PCIe3021_InitAndStartAnalogInputSequence Error :  Unknow Error ');
    exit;
  end;


  //Display purpose
  StartSequenceButton.Enabled := false;
  StopButton.Enabled := True ;

  Timer1.Enabled := True;

End;

procedure TForm1.StopButtonClick(Sender: TObject);
begin

      StopButton.Enabled := False;

      (* Stop the acquisition *)
      i_ReturnValue := i_PCIe3021_StopAnalogAcquisition(h_BoardHandle);

      StartSequenceButton.Enabled := True;

      Timer1.Enabled := False;

end;

procedure TForm1.Timer1Timer(Sender: TObject);

begin

  DebugLabel.Caption := 'Interupt source : ' + IntToStr(b_InterruptSource) + #10#13 + 'Nbr of Int : '+ IntToStr(b_ReceiveInterrupt) +  #10#13 +'Number of read packet : ' + IntToStr(li_read);

  resultLabel0.Caption := 'Ch 0 :' + Format('%.3f',[(valuesToDisplay[0]-32767)*(10.0/32767.0)]);
  resultLabel1.Caption := 'Ch 1 :' + Format('%.3f',[(valuesToDisplay[1]-32767)*(10.0/32767.0)]);
  resultLabel2.Caption := 'Ch 2 :' + Format('%.3f',[(valuesToDisplay[2]-32767)*(10.0/32767.0)]);
  resultLabel3.Caption := 'Ch 3 :' + Format('%.3f',[(valuesToDisplay[3]-32767)*(10.0/32767.0)]);
  resultLabel4.Caption := 'Ch 4 :' + Format('%.3f',[(valuesToDisplay[4]-32767)*(10.0/32767.0)]);
  resultLabel5.Caption := 'Ch 5 :' + Format('%.3f',[(valuesToDisplay[5]-32767)*(10.0/32767.0)]);
  resultLabel6.Caption := 'Ch 6 :' + Format('%.3f',[(valuesToDisplay[6]-32767)*(10.0/32767.0)]);
  resultLabel7.Caption := 'Ch 7 :' + Format('%.3f',[(valuesToDisplay[7]-32767)*(10.0/32767.0)]);
  resultLabel8.Caption := 'Ch 8 :' + Format('%.3f',[(valuesToDisplay[8]-32767)*(10.0/32767.0)]);
  resultLabel9.Caption := 'Ch 9 :' + Format('%.3f',[(valuesToDisplay[9]-32767)*(10.0/32767.0)]);
  resultLabel10.Caption := 'Ch 10 :' + Format('%.3f',[(valuesToDisplay[10]-32767)*(10.0/32767.0)]);
  resultLabel11.Caption := 'Ch 11 :' + Format('%.3f',[(valuesToDisplay[11]-32767)*(10.0/32767.0)]);
  resultLabel12.Caption := 'Ch 12 :' + Format('%.3f',[(valuesToDisplay[12]-32767)*(10.0/32767.0)]);
  resultLabel13.Caption := 'Ch 13 :' + Format('%.3f',[(valuesToDisplay[13]-32767)*(10.0/32767.0)]);
  resultLabel14.Caption := 'Ch 14 :' + Format('%.3f',[(valuesToDisplay[14]-32767)*(10.0/32767.0)]);
  resultLabel15.Caption := 'Ch 15 :' + Format('%.3f',[(valuesToDisplay[15]-32767)*(10.0/32767.0)]);

end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin

      (* Stop the acquisition *)
     i_ReturnValue := i_PCIe3021_StopAnalogAcquisition(h_BoardHandle);

      (* This function deinstalls the Interrupt Routine *)
	   i_ReturnValue := i_PCIe3021_ResetBoardIntRoutine(h_BoardHandle);

 	    (* Close the board handle *)
	   i_ReturnValue := i_PCIe3021_CloseBoard (h_BoardHandle);
     
end;

//For Display purpose
procedure TForm1.SERadioButtonClick(Sender: TObject);
begin

    Channel0CheckBox.Enabled := True;
    Channel1CheckBox.Enabled := True;
    Channel2CheckBox.Enabled := True;
    Channel3CheckBox.Enabled := True;
    Channel4CheckBox.Enabled := True;
    Channel5CheckBox.Enabled := True;
    Channel6CheckBox.Enabled := True;
    Channel7CheckBox.Enabled := True;
    Channel8CheckBox.Visible := True;
    Channel9CheckBox.Visible := True;
    Channel10CheckBox.Visible := True;
    Channel11CheckBox.Visible := True;
    Channel12CheckBox.Visible := True;
    Channel13CheckBox.Visible := True;
    Channel14CheckBox.Visible := True;
    Channel15CheckBox.Visible := True;
end;

//For Display purpose
procedure TForm1.DiffRadioButtonClick(Sender: TObject);
begin
    Channel0CheckBox.Enabled := True;
    Channel1CheckBox.Enabled := True;
    Channel2CheckBox.Enabled := True;
    Channel3CheckBox.Enabled := True;
    Channel4CheckBox.Enabled := True;
    Channel5CheckBox.Enabled := True;
    Channel6CheckBox.Enabled := True;
    Channel7CheckBox.Enabled := True;
    Channel8CheckBox.Visible := False;
    Channel8CheckBox.Checked := False;
    Channel9CheckBox.Visible := False;
    Channel9CheckBox.Checked := False;
    Channel10CheckBox.Visible := False;
    Channel10CheckBox.Checked := False;
    Channel11CheckBox.Visible := False;
    Channel11CheckBox.Checked := False;
    Channel12CheckBox.Visible := False;
    Channel12CheckBox.Checked := False;
    Channel13CheckBox.Visible := False;
    Channel13CheckBox.Checked := False;
    Channel14CheckBox.Visible := False;
    Channel14CheckBox.Checked := False;
    Channel15CheckBox.Visible := False;
    Channel15CheckBox.Checked := False;
end;


//For Display purpose
procedure TForm1.Channel0CheckBoxClick(Sender: TObject);
begin
  if (Channel0CheckBox.Checked= True) then
    begin
    resultLabel0.Visible := true;
    end
  else
    begin
    resultLabel0.Visible := false;
    end;
end;
//For Display purpose
procedure TForm1.Channel1CheckBoxClick(Sender: TObject);
begin
  if (Channel1CheckBox.Checked= True) then
    begin
    resultLabel1.Visible := true;
    end
  else
    begin
    resultLabel1.Visible := false;
    end;
end;
//For Display purpose
procedure TForm1.Channel2CheckBoxClick(Sender: TObject);
begin
  if (Channel2CheckBox.Checked= True) then
    begin
    resultLabel2.Visible := true;
    end
  else
    begin
    resultLabel2.Visible := false;
    end;
end;
//For Display purpose
procedure TForm1.Channel3CheckBoxClick(Sender: TObject);
begin
  if (Channel3CheckBox.Checked= True) then
    begin
    resultLabel3.Visible := true;
    end
  else
    begin
    resultLabel3.Visible := false;
    end;
end;
//For Display purpose
procedure TForm1.Channel4CheckBoxClick(Sender: TObject);
begin
  if (Channel4CheckBox.Checked= True) then
    begin
    resultLabel4.Visible := true;
    end
  else
    begin
    resultLabel4.Visible := false;
    end;
end;
//For Display purpose
procedure TForm1.Channel5CheckBoxClick(Sender: TObject);
begin
  if (Channel5CheckBox.Checked= True) then
    begin
    resultLabel5.Visible := true;
    end
  else
    begin
    resultLabel5.Visible := false;
    end;
end;
//For Display purpose
procedure TForm1.Channel6CheckBoxClick(Sender: TObject);
begin
  if (Channel6CheckBox.Checked= True) then
    begin
    resultLabel6.Visible := true;
    end
  else
    begin
    resultLabel6.Visible := false;
    end;
end;
//For Display purpose
procedure TForm1.Channel7CheckBoxClick(Sender: TObject);
begin
  if (Channel7CheckBox.Checked= True) then
    begin
    resultLabel7.Visible := true;
    end
  else
    begin
    resultLabel7.Visible := false;
    end;
end;
//For Display purpose
procedure TForm1.Channel8CheckBoxClick(Sender: TObject);
begin
  if (Channel8CheckBox.Checked= True) then
    begin
    resultLabel8.Visible := true;
    end
  else
    begin
    resultLabel8.Visible := false;
    end;
end;
//For Display purpose
procedure TForm1.Channel9CheckBoxClick(Sender: TObject);
begin
  if (Channel9CheckBox.Checked= True) then
    begin
    resultLabel9.Visible := true;
    end
  else
    begin
    resultLabel9.Visible := false;
    end;
end;
//For Display purpose
procedure TForm1.Channel10CheckBoxClick(Sender: TObject);
begin
  if (Channel10CheckBox.Checked= True) then
    begin
    resultLabel10.Visible := true;
    end
  else
    begin
    resultLabel10.Visible := false;
    end;
end;
//For Display purpose
procedure TForm1.Channel11CheckBoxClick(Sender: TObject);
begin
  if (Channel11CheckBox.Checked= True) then
    begin
    resultLabel11.Visible := true;
    end
  else
    begin
    resultLabel11.Visible := false;
    end;
end;
//For Display purpose
procedure TForm1.Channel12CheckBoxClick(Sender: TObject);
begin
  if (Channel12CheckBox.Checked= True) then
    begin
    resultLabel12.Visible := true;
    end
  else
    begin
    resultLabel12.Visible := false;
    end;
end;
//For Display purpose
procedure TForm1.Channel13CheckBoxClick(Sender: TObject);
begin
  if (Channel13CheckBox.Checked= True) then
    begin
    resultLabel13.Visible := true;
    end
  else
    begin
    resultLabel13.Visible := false;
    end;
end;
//For Display purpose
procedure TForm1.Channel14CheckBoxClick(Sender: TObject);
begin
  if (Channel14CheckBox.Checked= True) then
    begin
    resultLabel14.Visible := true;
    end
  else
    begin
    resultLabel14.Visible := false;
    end;
end;
//For Display purpose
procedure TForm1.Channel15CheckBoxClick(Sender: TObject);
begin
  if (Channel15CheckBox.Checked= True) then
    begin
    resultLabel15.Visible := true;
    end
  else
    begin
    resultLabel15.Visible := false;
    end;
end;

procedure TForm1.IRCButtonClick(Sender: TObject);
begin
  b_ReceiveInterrupt := 0;
end;

end.

