unit TimerInterrupt;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,PCIe3021, StdCtrls, ExtCtrls ;

type
  TForm1 = class(TForm)
    StartButton: TButton;
    TriggerButton: TButton;
    StopButton: TButton;
    ExecutionLabel1: TLabel;
    StaticText1: TStaticText;
    Timer1: TTimer;
    TimerValueLabel: TLabel;
    InterruptValueLabel: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure StartButtonClick(Sender: TObject);
    procedure TriggerButtonClick(Sender: TObject);
    procedure StopButtonClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  
  i_ReturnValue      : Integer;
  h_BoardHandle      : THandle; (*Byte*)
  b_ReceiveInterrupt : Byte;

implementation

{$R *.dfm}

Procedure v_InterruptRoutine   (h_BoardHandle       : THANDLE;
                                b_FIFOOverflow      : Byte;
								                dw_InterruptSource  : Byte;
                                b_InterruptMask     : Byte;
                                var w_Args          : word;
								                dw_ArgsCount        : LongWord);cdecl;				

	Begin

	   if(dw_InterruptSource and 2) = 2  then 
	   b_ReceiveInterrupt := b_ReceiveInterrupt + 1;

	End;


procedure TForm1.FormCreate(Sender: TObject);
Var
     b_NbrOfBoardFound      : Byte;
     s_ReturnValue     : String;
begin

			{* Get the number of APCIe-3021 found  *}
			i_ReturnValue := i_PCIe3021_GetNumberOfBoards (b_NbrOfBoardFound);
      s_ReturnValue := IntToStr (b_NbrOfBoardFound);
      ExecutionLabel1.Caption := s_ReturnValue;

      {* Get the board handle *}
      i_ReturnValue := i_PCIe3021_OpenBoardViaIndex (0, h_BoardHandle);

      {* Set Board Routine *}
      i_ReturnValue := i_PCIe3021_SetBoardIntRoutine(h_BoardHandle, @v_InterruptRoutine);
end;


procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin

     (* This function stop the timer*)
     i_ReturnValue := i_PCIe3021_StopTimer (h_BoardHandle);

      (* This function deinstalls the Interrupt Routine *)
	   i_ReturnValue := i_PCIe3021_ResetBoardIntRoutine(h_BoardHandle);

 	   (* Close the board handle *)
	   i_ReturnValue := i_PCIe3021_CloseBoard (h_BoardHandle);
end;



procedure TForm1.StartButtonClick(Sender: TObject);
 Var
      b_TimerMode             : Byte;
      b_TimeBase            	: Byte;
	    b_OutputMode			      : Byte;
	    b_InterruptEnabled		  : Byte;
      w_ReloadValue           : word;
begin

     StartButton.enabled := False;
     StopButton.enabled  := True;

     b_TimerMode               	 := PCIE3021_TIMER_MODE_2;              // mode 2
     b_TimeBase              	   := PCIE3021_TIME_BASE_MILLISECONDS;    // ms time base
     b_OutputMode          		   := PCIE3021_OUTPUT_DISABLED;           // output disabled
     b_InterruptEnabled          := 1;                                  // interrupt enabled
     w_ReloadValue               := 5000;                               // 5000ms
     b_ReceiveInterrupt          := 0;

    
     
    (**********************************************
     * The function InitAndStartTimer selects the *
     * operating mode of the first timer          *
     **********************************************)
     i_ReturnValue := i_PCIe3021_InitAndStartTimer (h_BoardHandle,b_TimerMode,b_TimeBase,b_OutputMode,b_InterruptEnabled,w_ReloadValue);

end;

procedure TForm1.TriggerButtonClick(Sender: TObject);
begin


     i_ReturnValue := i_PCIe3021_TriggerTimer (h_BoardHandle);


end;

procedure TForm1.StopButtonClick(Sender: TObject);
begin

    i_ReturnValue := i_PCIe3021_StopTimer (h_BoardHandle);

    StartButton.enabled := True;
    StopButton.enabled  := False;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
Var
l_TimerValue : Word;
s_TimerValue : String;
s_InterruptValue : String;

begin


   i_ReturnValue := i_PCIe3021_ReadTimerValue  (h_BoardHandle,  l_TimerValue );

   s_TimerValue := IntToStr (l_TimerValue);
   TimerValueLabel.Caption := 'Timer Value : ' + s_TimerValue;

   s_InterruptValue := IntToStr (b_ReceiveInterrupt);
   InterruptValueLabel.Caption := 'Number of Interrupt : ' + IntToStr(b_ReceiveInterrupt);

end;



end.
