using System;
using System.Collections.Generic;
using System.Text;

namespace PCIe3021_NET
{
    /// <summary>
    /// Store the data of an end of sequence event
    /// End of sequence event is used when using ReadMoreAnalogInput or Read1AnalogInput with interrupt flag enabled
    /// </summary>
    public class EndOfSequenceEventArgs
    {
        /// <summary>
        /// Specify if the FIFO has overflow
        /// </summary>
        public byte FifoOverflow;
        /// <summary>
        /// The mask that has generated the interruption
        /// </summary>
        public uint InterruptMask;
        /// <summary>
        /// The size of data
        /// </summary>
        public uint ArgsSize;
        /// <summary>
        /// The values
        /// </summary>
        public ushort[] Args;
        /// <summary>
        /// Create the array
        /// </summary>
        public EndOfSequenceEventArgs()
        {
            // Maximum size is 16
            this.Args = new ushort[16];
        }
    }
}
