Attribute VB_Name = "Interrupt"
Global saveArray As INTEGER_ARRAY_256
Global numberOfInterruptsReceived As Byte


Sub interruptRoutine(ByVal deviceHandle As Long, _
                     ByVal fifoOverflow As Byte, _
                     ByVal interruptSource As Long, _
                     ByVal interruptMask As Long, _
                     inputValues As INTEGER_ARRAY_16, _
                     ByVal channelNumber As Long)
Dim i As Long
Dim data As INTEGER_ARRAY_256
Dim dataSize As Long
Dim l_ReturnValue As Long

    If (fifoOverflow = 1) Then
        i_Return = MsgBox("Error: interrupt FIFO overflow. That means that your software does not handle the interrupts fast enough.\n", 32, "ERROR")
    End If
    
    For i = 0 To channelNumber - 1
        data.i_Value(i) = 0
        saveArray.i_Value(i) = 0
    Next

    dataSize = channelNumber * Len(dataSize)
    l_ReturnValue = l_PCIe3021_ReadSequenceData(deviceHandle, dataSize, data)
    If (l_ReturnValue <= 0) Then
        i_Return = MsgBox("Read sequence data failed. Error: " + CStr(l_ReturnValue), 32, "ERROR")
        Exit Sub
    End If
    For i = 0 To channelNumber - 1
        saveArray.i_Value(i) = data.i_Value(i)
    Next

    numberOfInterruptsReceived = (numberOfInterruptsReceived + 1) Mod 3
End Sub
